//*******************************************************************************
//* FILE NAME: arm_control.h
//*
//* DESCRIPTION: 
//*  multi-jointed arm control
//*******************************************************************************

#ifndef __arm_control_h_
#define __arm_control_h_

#define TURRET_MIN  417	//was  290
#define TURRET_MAX  667	//was 756
#define JOINT1_MIN   425 //large sprocket 377   //old gearing 383
#define JOINT1_MAX  620 //large sprocket 700	// old gearing 607
#define JOINT2_MIN    74
#define JOINT2_MAX  854
#define JOINT3_MIN   100 // was 420
#define JOINT3_MAX  800 //was 700

// Known right angles of each arm segment
#define SHOULDER_90DEGREES	455 // 517	// old gearing 495
#define ELBOW_90DEGREES		270
#define WRIST_90DEGREES		700	

#define DUNK 20 

// HIGH  (position=1)
#define JOINT1_HIGH_MIN   620 // large sprocket 690 // 695 	// was 700 (old gearing 607
#define JOINT1_HIGH_MAX  620 //large sprocket 690 // 695	// was 700( old gearing 607
#define JOINT2_HIGH_MIN   500 // was 584
#define JOINT2_HIGH_MAX  500 // was 584
#define JOINT3_HIGH_MIN   730 // was 673
#define JOINT3_HIGH_MAX  730 // was 673

// MEDIUM  (position=2)
#define JOINT1_MEDIUM_MIN  620 // large sprocket 685 // 700 // was 720	// was 700 (old gearing 615)
#define JOINT1_MEDIUM_MAX  620 // large sprocket 685 // 700// was 715	// was 695 (old gearing 604)
#define JOINT2_MEDIUM_MIN  650 // was 650 // was 715
#define JOINT2_MEDIUM_MAX  650 // was 640 // was 705
#define JOINT3_MEDIUM_MIN   556 // 610 //was 663
#define JOINT3_MEDIUM_MAX  556 // 610 // was 663

// LOW  (position=3)
#define JOINT1_LOW_MIN   586 // large sprocket 645 //660 // 665 // 684// was 647
#define JOINT1_LOW_MAX  580 // large sprocket 635 //640 // 656 // 662 // was 625
#define JOINT2_LOW_MIN   854
#define JOINT2_LOW_MAX  727
#define JOINT3_LOW_MIN   340 //280 //320 // 419
#define JOINT3_LOW_MAX  340 //280 //460 // 490

// FLOOR (position=4)
#define JOINT1_FLOOR_MIN   545// was 535 //large sprocket 560 // 580 // was 565 (old gearing 525)
#define JOINT1_FLOOR_MAX  545 // was 535 //large sprocket 560 // 580 // was 565 (old gearing 525)
#define JOINT2_FLOOR_MIN   824 // really 783 but kludged // 810 // was 830
#define JOINT2_FLOOR_MAX 	742 // was 775 //was 760,
#define JOINT3_FLOOR_MIN   400 // was 443
#define JOINT3_FLOOR_MAX  400 //365 //was 480

// PICKUP (position=5)
#define JOINT1_PICKUP_MIN  517 // large sprocket 530 // was 560 // old gearing  540
#define JOINT1_PICKUP_MAX  517 // large sprocket 530 // was 562 // old gearing 542
#define JOINT2_PICKUP_MIN   814 // really 762 but playing a trick // was 844
#define JOINT2_PICKUP_MAX  710 //700
#define JOINT3_PICKUP_MIN   400 //was 443
#define JOINT3_PICKUP_MAX  400 //was 443

// Known right angles of each arm segment
#define SHOULDER_HUMANLOAD	455 // 517	// old gearing 495
#define ELBOW_HUMANLOAD		270
#define WRIST_HUMANLOAD		350
// Intermediate joints of arm segments
#define SHOULDER_HUMANLOAD1	680
#define ELBOW_HUMANLOAD1	370


// STOWED (special button)
#define TURRET_STOWED		517
#define SHOULDER_STOWED 	425 // 377 // old gearing 383
#define ELBOW_STOWED  	74
#define WRIST_STOWED 		700
// Intermediate joints of arm segments
#define SHOULDER_STOW1	455 // 517	// 90 degree position - old gearing 495
#define ELBOW_STOW1		270


// UNFOLD (position=7)
// STATE 1 - Intermediate joints of arm segments
#define TURRET_UNFOLD_STATE1	517
#define JOINT1_UNFOLD_STATE1	455 // 517 // old gearing 570
#define JOINT2_UNFOLD_STATE1  	74
#define JOINT3_UNFOLD_STATE1 	700
// STATE 2 HIGH scoring position
#define TURRET_UNFOLD_STATE2	523
#define JOINT1_UNFOLD_STATE2	JOINT1_HIGH_MIN // was 700 - old gearing 607
#define JOINT2_UNFOLD_STATE2  	JOINT2_MEDIUM_MIN // was JOINT2_HIGH_MIN // was 584
#define JOINT3_UNFOLD_STATE2 	JOINT3_HIGH_MIN // was 673

#define NULL 		0
#define HIGH 		1
#define MEDIUM 	2
#define LOW 		3
#define FLOOR  	4
#define PICKUP		5
#define STOWED 	6
#define UNFOLD	7
#define POT_RESET 8
#define TEST 		9

#define MANUAL_MODE 		10
#define HUMANLOAD_MODE		11
#define AUTO_MODE			12

void arm_stowed(unsigned int *, unsigned int *, unsigned int *, unsigned int *);
void arm_unfold(unsigned int *, unsigned int *, unsigned int *, unsigned int *);
void arm_lookup(unsigned char , unsigned int , unsigned int *);
void Arm_Control(void);
void arm_movement(unsigned int , unsigned int , unsigned int , unsigned int );
void Coefficient_Input(unsigned int *, unsigned int *, unsigned int *, unsigned int *);
void arm_lookup_elbow(unsigned char , unsigned int , unsigned int *);
void arm_lookup_shoulder(unsigned char , unsigned int *, unsigned int );
void arm_lookup_wrist(unsigned char , unsigned int *, unsigned int );

extern char arm_position;

#endif
