/*******************************************************************************
* FILE NAME: clock_routines.h
*
* DESCRIPTION:
*  Clock time keeping stuff  
*
*
*******************************************************************************/


#ifndef __clock_routines_h_
#define __clock_routines_h_

#include <timers.h>

#define ENDOFAUTO 15	// Duration of Autonomous mode
#define ENDOFOPR 120	// Duration of Operator mode
#define CLOCKOFFSET 60535  //Set timer for 4ms

#ifdef VARIABLE_DECLARE
  volatile unsigned long MasterClockms=0;	// 4 millisecond clock
  unsigned long Clockms=0;	// 1 millisecond clock
  unsigned long Clockds=0;	// 100 millisecond
  unsigned long Clocksec=0; // 1 second clock
  char EndOfAuto=FALSE; // One second Flag warning of the pending end of Autonomous mode
  char EndOfOpr=FALSE; // One second Flag warning of the pending end of Operator mode
  unsigned int LastSecOfAuto=255;
  unsigned int LastSecOfOpr=255;
#else
  extern volatile unsigned long MasterClockms;
  extern unsigned long Clockms;
  extern unsigned long Clockds;
  extern unsigned long Clocksec;
  extern char EndOfAuto;
  extern char EndOfOpr;
  extern unsigned int LastSecOfAuto;
  extern unsigned int LastSecOfOpr;
#endif

void Initialize_Clock(void);
void Update_Clock(void);

#endif
